Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_noopenmp_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_noopenmp_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_noopenmp_mod.F90	(revision 4727)
@@ -421,40 +421,39 @@
        IF (knon /=0) THEN
           CALL Init_orchidee_index(knon,orch_comm,knindex,offset,ktindex)
-
-#ifndef CPP_MPI
-          ! Interface for ORCHIDEE compiled in sequential mode(without preprocessing flag CPP_MPI)
-          CALL intersurf_main (itime+itau_phy-1, nbp_lon, nbp_lat, knon, ktindex, dtime, &
-               lrestart_read, lrestart_write, lalo, &
-               contfrac, neighbours, resolution, date0, &
-               zlev,  u1_lay, v1_lay, spechum, temp_air, epot_air, ccanopy, &
-               cdrag, petA_orc, peqA_orc, petB_orc, peqB_orc, &
-               precip_rain, precip_snow, lwdown, swnet, swdown, ps, &
-               evap, fluxsens, fluxlat, coastalflow, riverflow, &
-               tsol_rad, tsurf_new, qsurf, albedo_out, emis_new, z0_new, &
-               lon_scat, lat_scat, q2m, t2m &
+          
+          IF (.NOT. using_mpi) THEN
+            ! Interface for ORCHIDEE compiled in sequential mode(without preprocessing flag CPP_MPI)
+            CALL intersurf_main (itime+itau_phy-1, nbp_lon, nbp_lat, knon, ktindex, dtime, &
+                 lrestart_read, lrestart_write, lalo, &
+                 contfrac, neighbours, resolution, date0, &
+                 zlev,  u1_lay, v1_lay, spechum, temp_air, epot_air, ccanopy, &
+                 cdrag, petA_orc, peqA_orc, petB_orc, peqB_orc, &
+                 precip_rain, precip_snow, lwdown, swnet, swdown, ps, &
+                 evap, fluxsens, fluxlat, coastalflow, riverflow, &
+                 tsol_rad, tsurf_new, qsurf, albedo_out, emis_new, z0_new, &
+                 lon_scat, lat_scat, q2m, t2m &
 #ifdef ORCH_NEW
-               , nb_fields_cpl, fields_cpl)
+                 , nb_fields_cpl, fields_cpl)
 #else
-               )
+                 )
 #endif
 
-#else          
-          ! Interface for ORCHIDEE version 1.9 or later(1.9.2, 1.9.3, 1.9.4, 1.9.5) compiled in parallel mode(with preprocessing flag CPP_MPI)
-          CALL intersurf_main (itime+itau_phy-1, nbp_lon, nbp_lat, offset, knon, ktindex, & 
-               orch_comm, dtime, lrestart_read, lrestart_write, lalo, &
-               contfrac, neighbours, resolution, date0, &
-               zlev,  u1_lay(1:knon), v1_lay(1:knon), spechum(1:knon), temp_air(1:knon), epot_air(1:knon), ccanopy(1:knon), &
-               cdrag(1:knon), petA_orc(1:knon), peqA_orc(1:knon), petB_orc(1:knon), peqB_orc(1:knon), &
-               precip_rain(1:knon), precip_snow(1:knon), lwdown(1:knon), swnet(1:knon), swdown(1:knon), ps(1:knon), &
-               evap(1:knon), fluxsens(1:knon), fluxlat(1:knon), coastalflow(1:knon), riverflow(1:knon), &
-               tsol_rad(1:knon), tsurf_new(1:knon), qsurf(1:knon), albedo_out(1:knon,:), emis_new(1:knon), z0_new(1:knon), &
-               lon_scat, lat_scat, q2m, t2m &
+          ELSE          
+            ! Interface for ORCHIDEE version 1.9 or later(1.9.2, 1.9.3, 1.9.4, 1.9.5) compiled in parallel mode(with preprocessing flag CPP_MPI)
+            CALL intersurf_main (itime+itau_phy-1, nbp_lon, nbp_lat, offset, knon, ktindex, & 
+                 orch_comm, dtime, lrestart_read, lrestart_write, lalo, &
+                 contfrac, neighbours, resolution, date0, &
+                 zlev,  u1_lay(1:knon), v1_lay(1:knon), spechum(1:knon), temp_air(1:knon), epot_air(1:knon), ccanopy(1:knon), &
+                 cdrag(1:knon), petA_orc(1:knon), peqA_orc(1:knon), petB_orc(1:knon), peqB_orc(1:knon), &
+                 precip_rain(1:knon), precip_snow(1:knon), lwdown(1:knon), swnet(1:knon), swdown(1:knon), ps(1:knon), &
+                 evap(1:knon), fluxsens(1:knon), fluxlat(1:knon), coastalflow(1:knon), riverflow(1:knon), &
+                 tsol_rad(1:knon), tsurf_new(1:knon), qsurf(1:knon), albedo_out(1:knon,:), emis_new(1:knon), z0_new(1:knon), &
+                 lon_scat, lat_scat, q2m, t2m &
 #ifdef ORCH_NEW
-               , nb_fields_cpl, fields_cpl(1:knon,:))
+                 , nb_fields_cpl, fields_cpl(1:knon,:))
 #else
-               )
+                 )
 #endif
-#endif
-          
+          ENDIF
        ENDIF
 
@@ -467,37 +466,37 @@
 
     IF (knon /=0) THEN
-#ifndef CPP_MPI
-       ! Interface for ORCHIDEE compiled in sequential mode(without preprocessing flag CPP_MPI)
-       CALL intersurf_main (itime+itau_phy, nbp_lon, nbp_lat, knon, ktindex, dtime, &
-            lrestart_read, lrestart_write, lalo, &
-            contfrac, neighbours, resolution, date0, &
-            zlev,  u1_lay, v1_lay, spechum, temp_air, epot_air, ccanopy, &
-            cdrag, petA_orc, peqA_orc, petB_orc, peqB_orc, &
-            precip_rain, precip_snow, lwdown, swnet, swdown_vrai, ps, &
-            evap, fluxsens, fluxlat, coastalflow, riverflow, &
-            tsol_rad, tsurf_new, qsurf, albedo_out, emis_new, z0_new, &
-            lon_scat, lat_scat, q2m, t2m &
+       IF (.NOT. using_mpi) THEN
+         ! Interface for ORCHIDEE compiled in sequential mode(without preprocessing flag CPP_MPI)
+         CALL intersurf_main (itime+itau_phy, nbp_lon, nbp_lat, knon, ktindex, dtime, &
+              lrestart_read, lrestart_write, lalo, &
+              contfrac, neighbours, resolution, date0, &
+              zlev,  u1_lay, v1_lay, spechum, temp_air, epot_air, ccanopy, &
+              cdrag, petA_orc, peqA_orc, petB_orc, peqB_orc, &
+              precip_rain, precip_snow, lwdown, swnet, swdown_vrai, ps, &
+              evap, fluxsens, fluxlat, coastalflow, riverflow, &
+              tsol_rad, tsurf_new, qsurf, albedo_out, emis_new, z0_new, &
+              lon_scat, lat_scat, q2m, t2m &
 #ifdef ORCH_NEW
-            , nb_fields_cpl, fields_cpl)
+              , nb_fields_cpl, fields_cpl)
 #else
-            )
+              )
 #endif
+       ELSE
+         ! Interface for ORCHIDEE version 1.9 or later compiled in parallel mode(with preprocessing flag CPP_MPI)
+         CALL intersurf_main (itime+itau_phy, nbp_lon, nbp_lat,offset, knon, ktindex, & 
+              orch_comm,dtime, lrestart_read, lrestart_write, lalo, &
+              contfrac, neighbours, resolution, date0, &
+              zlev,  u1_lay(1:knon), v1_lay(1:knon), spechum(1:knon), temp_air(1:knon), epot_air(1:knon), ccanopy(1:knon), &
+              cdrag(1:knon), petA_orc(1:knon), peqA_orc(1:knon), petB_orc(1:knon), peqB_orc(1:knon), &
+              precip_rain(1:knon), precip_snow(1:knon), lwdown(1:knon), swnet(1:knon), swdown_vrai(1:knon), ps(1:knon), &
+              evap(1:knon), fluxsens(1:knon), fluxlat(1:knon), coastalflow(1:knon), riverflow(1:knon), &
+              tsol_rad(1:knon), tsurf_new(1:knon), qsurf(1:knon), albedo_out(1:knon,:), emis_new(1:knon), z0_new(1:knon), &
+              lon_scat, lat_scat, q2m, t2m &
+#ifdef ORCH_NEW
+              , nb_fields_cpl, fields_cpl(1:knon,:))
 #else
-       ! Interface for ORCHIDEE version 1.9 or later compiled in parallel mode(with preprocessing flag CPP_MPI)
-       CALL intersurf_main (itime+itau_phy, nbp_lon, nbp_lat,offset, knon, ktindex, & 
-            orch_comm,dtime, lrestart_read, lrestart_write, lalo, &
-            contfrac, neighbours, resolution, date0, &
-            zlev,  u1_lay(1:knon), v1_lay(1:knon), spechum(1:knon), temp_air(1:knon), epot_air(1:knon), ccanopy(1:knon), &
-            cdrag(1:knon), petA_orc(1:knon), peqA_orc(1:knon), petB_orc(1:knon), peqB_orc(1:knon), &
-            precip_rain(1:knon), precip_snow(1:knon), lwdown(1:knon), swnet(1:knon), swdown_vrai(1:knon), ps(1:knon), &
-            evap(1:knon), fluxsens(1:knon), fluxlat(1:knon), coastalflow(1:knon), riverflow(1:knon), &
-            tsol_rad(1:knon), tsurf_new(1:knon), qsurf(1:knon), albedo_out(1:knon,:), emis_new(1:knon), z0_new(1:knon), &
-            lon_scat, lat_scat, q2m, t2m &
-#ifdef ORCH_NEW
-            , nb_fields_cpl, fields_cpl(1:knon,:))
-#else
-            )
+              )
 #endif
-#endif
+       ENDIF
     ENDIF
 
@@ -545,9 +544,5 @@
     
     USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
-
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif    
-
+    USE lmdz_mpi
 
 ! Input arguments
@@ -564,7 +559,5 @@
 ! Local varables
 !****************************************************************************************
-#ifdef CPP_MPI
     INTEGER, DIMENSION(MPI_STATUS_SIZE)   :: status
-#endif
 
     INTEGER                               :: MyLastPoint
@@ -580,8 +573,6 @@
     
     IF (is_parallel) THEN
-#ifdef CPP_MPI    
        CALL MPI_COMM_SIZE(orch_comm,mpi_size_orch,ierr)
        CALL MPI_COMM_RANK(orch_comm,mpi_rank_orch,ierr)
-#endif
     ELSE
        mpi_rank_orch=0
@@ -591,13 +582,9 @@
     IF (is_parallel) THEN
        IF (mpi_rank_orch /= 0) THEN
-#ifdef CPP_MPI
           CALL MPI_RECV(LastPoint,1,MPI_INTEGER,mpi_rank_orch-1,1234,orch_comm,status,ierr)
-#endif
        ENDIF
        
        IF (mpi_rank_orch /= mpi_size_orch-1) THEN
-#ifdef CPP_MPI
           CALL MPI_SEND(MyLastPoint,1,MPI_INTEGER,mpi_rank_orch+1,1234,orch_comm,ierr)  
-#endif
        ENDIF
     ENDIF
@@ -617,9 +604,5 @@
 ! 
   SUBROUTINE Get_orchidee_communicator(knon,orch_comm)
-    
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif    
-
+  USE lmdz_mpi
 
     INTEGER,INTENT(IN)  :: knon
@@ -638,7 +621,5 @@
     ENDIF
     
-#ifdef CPP_MPI    
     CALL MPI_COMM_SPLIT(COMM_LMDZ_PHY,color,mpi_rank,orch_comm,ierr)
-#endif
     
   END SUBROUTINE Get_orchidee_communicator
@@ -650,8 +631,5 @@
     USE indice_sol_mod
     USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
-
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif    
+    USE lmdz_mpi
 
 ! Input arguments
@@ -688,9 +666,5 @@
        knon_nb(:)=knon
     ELSE  
-       
-#ifdef CPP_MPI  
        CALL MPI_GATHER(knon,1,MPI_INTEGER,knon_nb,1,MPI_INTEGER,0,COMM_LMDZ_PHY,ierr)
-#endif
-       
     ENDIF
     
@@ -714,10 +688,6 @@
        ktindex_g(:)=ktindex_p(:)
     ELSE
-       
-#ifdef CPP_MPI  
        CALL MPI_GATHERV(ktindex_p,knon,MPI_INTEGER,ktindex_g,knon_nb,&
             displs,MPI_INTEGER,0,COMM_LMDZ_PHY,ierr)
-#endif
-       
     ENDIF
     
@@ -776,5 +746,4 @@
           neighbours(:,i)=neighbours_g(:,i)
        ELSE
-#ifdef CPP_MPI
           IF (knon > 0) THEN
              ! knon>0, scattter global field neighbours_g from master process to local process
@@ -784,5 +753,4 @@
              CALL MPI_SCATTERV(neighbours_g(:,i),knon_nb,displs,MPI_INTEGER,var_tmp,knon,MPI_INTEGER,0,COMM_LMDZ_PHY,ierr) 
           END IF
-#endif
        ENDIF
     ENDDO
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_nounstruct_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_nounstruct_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_nounstruct_mod.F90	(revision 4727)
@@ -525,9 +525,6 @@
   SUBROUTINE Get_orchidee_communicator(orch_comm,orch_omp_size,orch_omp_rank)
   USE  mod_surf_para
+  USE lmdz_mpi
       
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif    
-
     INTEGER,INTENT(OUT) :: orch_comm
     INTEGER,INTENT(OUT) :: orch_omp_size
@@ -548,7 +545,5 @@
       ENDIF
     
-#ifdef CPP_MPI    
       CALL MPI_COMM_SPLIT(COMM_LMDZ_PHY,color,mpi_rank,orch_comm,ierr)
-#endif
     
     ENDIF
@@ -575,8 +570,5 @@
     USE mod_surf_para    
     USE indice_sol_mod
-
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif    
+    USE lmdz_mpi
 
 ! Input arguments
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_noz0h_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_noz0h_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_noz0h_mod.F90	(revision 4727)
@@ -525,9 +525,6 @@
   SUBROUTINE Get_orchidee_communicator(orch_comm,orch_omp_size,orch_omp_rank)
   USE  mod_surf_para
+  USE lmdz_mpi
       
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif    
-
     INTEGER,INTENT(OUT) :: orch_comm
     INTEGER,INTENT(OUT) :: orch_omp_size
@@ -548,7 +545,5 @@
       ENDIF
     
-#ifdef CPP_MPI    
       CALL MPI_COMM_SPLIT(COMM_LMDZ_PHY,color,mpi_rank,orch_comm,ierr)
-#endif
     
     ENDIF
@@ -575,8 +570,5 @@
     USE mod_surf_para    
     USE indice_sol_mod
-
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif    
+    USE lmdz_mpi
 
 ! Input arguments
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_landice_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_landice_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_landice_mod.F90	(revision 4727)
@@ -12,10 +12,11 @@
        rmu0, lwdownm, albedo, pphi1, &
        swnet, lwnet, tsurf, p1lay, &
-       cdragh, cdragm, precip_rain, precip_snow, temp_air, spechum, &
+       cdragh, cdragm, precip_rain, precip_snow, precip_bs, temp_air, spechum, &
        AcoefH, AcoefQ, BcoefH, BcoefQ, &
        AcoefU, AcoefV, BcoefU, BcoefV, &
+       AcoefQBS, BcoefQBS, &
        ps, u1, v1, gustiness, rugoro, pctsrf, &
-       snow, qsurf, qsol, agesno, &
-       tsoil, z0m, z0h, SFRWL, alb_dir, alb_dif, evap, fluxsens, fluxlat, &
+       snow, qsurf, qsol, qbs1, agesno, &
+       tsoil, z0m, z0h, SFRWL, alb_dir, alb_dif, evap, fluxsens, fluxlat, fluxbs, &
        tsurf_new, dflux_s, dflux_l, &
        alt, slope, cloudf, &
@@ -30,8 +31,9 @@
     USE cpl_mod,          ONLY : cpl_send_landice_fields
     USE calcul_fluxs_mod
+    USE phys_local_var_mod, ONLY : zxrhoslic, zxustartlic
     USE phys_output_var_mod, ONLY : snow_o,zfra_o
 !FC
     USE ioipsl_getin_p_mod, ONLY : getin_p
-
+    USE lmdz_blowing_snow_ini, ONLY : zeta_bs, pbst_bs, prt_bs, iflag_saltation_bs
 
 #ifdef CPP_INLANDSIS
@@ -56,11 +58,12 @@
     REAL, DIMENSION(klon), INTENT(IN)             :: p1lay
     REAL, DIMENSION(klon), INTENT(IN)             :: cdragh, cdragm
-    REAL, DIMENSION(klon), INTENT(IN)             :: precip_rain, precip_snow
+    REAL, DIMENSION(klon), INTENT(IN)             :: precip_rain, precip_snow, precip_bs
     REAL, DIMENSION(klon), INTENT(IN)             :: temp_air, spechum
     REAL, DIMENSION(klon), INTENT(IN)             :: AcoefH, AcoefQ
     REAL, DIMENSION(klon), INTENT(IN)             :: BcoefH, BcoefQ
     REAL, DIMENSION(klon), INTENT(IN)             :: AcoefU, AcoefV, BcoefU, BcoefV
+    REAL, DIMENSION(klon), INTENT(IN)             :: AcoefQBS, BcoefQBS
     REAL, DIMENSION(klon), INTENT(IN)             :: ps
-    REAL, DIMENSION(klon), INTENT(IN)             :: u1, v1, gustiness
+    REAL, DIMENSION(klon), INTENT(IN)             :: u1, v1, gustiness, qbs1
     REAL, DIMENSION(klon), INTENT(IN)             :: rugoro
     REAL, DIMENSION(klon,nbsrf), INTENT(IN)       :: pctsrf
@@ -94,4 +97,5 @@
 !albedo SB <<<
     REAL, DIMENSION(klon), INTENT(OUT)            :: evap, fluxsens, fluxlat
+    REAL, DIMENSION(klon), INTENT(OUT)            :: fluxbs
     REAL, DIMENSION(klon), INTENT(OUT)            :: tsurf_new
     REAL, DIMENSION(klon), INTENT(OUT)            :: dflux_s, dflux_l      
@@ -134,5 +138,12 @@
 
     REAL,DIMENSION(klon) :: alb1,alb2
+    REAL,DIMENSION(klon) :: precip_totsnow, evap_totsnow
     REAL, DIMENSION (klon,6) :: alb6
+    REAL                   :: rho0, rhoice, ustart0,esalt, rhod
+    REAL                   :: lambdasalt,fluxsalt, csalt, nunu, aa, bb, cc
+    REAL                   :: tau_dens, tau_dens0, tau_densmin, rhomax, rhohard
+    REAL, DIMENSION(klon)  :: ws1, rhos, ustart, qsalt, hsalt, snowini
+    REAL                   :: maxerosion ! in kg/s   
+
 ! End definition
 !****************************************************************************************
@@ -165,5 +176,5 @@
     alb2(:) = 999999.
     alb1(:) = 999999.
-    
+    fluxbs(:)=0.  
     runoff(:) = 0.
 !****************************************************************************************
@@ -173,4 +184,6 @@
     radsol(:) = 0.0
     radsol(1:knon) = swnet(1:knon) + lwnet(1:knon)
+
+!****************************************************************************************
 
 !****************************************************************************************
@@ -264,5 +277,4 @@
 
 
-
     ELSE 
 
@@ -314,12 +326,4 @@
          flux_u1, flux_v1)
 
-!****************************************************************************************
-! Calculate snow height, age, run-off,..
-!    
-!****************************************************************************************
-    CALL fonte_neige(knon, is_lic, knindex, dtime, &
-         tsurf, precip_rain, precip_snow, &
-         snow, qsol, tsurf_new, evap)
-
 
 !****************************************************************************************
@@ -327,10 +331,12 @@
 !
 !****************************************************************************************
+ 
     CALL albsno(klon,knon,dtime,agesno(:),alb_neig(:), precip_snow(:))  
 
-    WHERE (snow(1 : knon) .LT. 0.0001) agesno(1 : knon) = 0.
-    zfra(1:knon) = MAX(0.0,MIN(1.0,snow(1:knon)/(snow(1:knon)+10.0)))
-    alb1(1:knon) = alb_neig(1:knon)*zfra(1:knon) + &
-         0.6 * (1.0-zfra(1:knon))
+
+! EV: following lines are obsolete since we set alb1 and alb2 to constant values
+! I therefore comment them
+!    alb1(1:knon) = alb_neig(1:knon)*zfra(1:knon) + &
+!         0.6 * (1.0-zfra(1:knon))
 !
 !IM: plusieurs choix/tests sur l'albedo des "glaciers continentaux"
@@ -354,4 +360,113 @@
     !z0m = SQRT(z0m**2+rugoro**2)
 
+
+
+  ! Simple blowing snow param
+  if (ok_bs) then
+       ustart0 = 0.211
+       rhoice = 920.0
+       rho0 = 300.0
+       rhomax=450.0
+       rhohard=450.0
+       tau_dens0=86400.0*10.  ! 10 days by default, in s
+       tau_densmin=21600.0    ! 1/4 days according to in situ obs by C. Amory during blowing snow + 
+                              ! Marshall et al. 1999 (snow densification during rain)
+
+       ! computation of threshold friction velocity
+       ! which depends on surface snow density
+       do j = 1, knon
+           ! estimation of snow density
+           ! snow density increases with snow age and
+           ! increases even faster in case of sedimentation of blowing snow or rain
+           tau_dens=max(tau_densmin, tau_dens0*exp(-abs(precip_bs(j))/pbst_bs - & 
+                    abs(precip_rain(j))/prt_bs)*exp(-max(tsurf(j)-272.0,0.)))
+           rhos(j)=rho0+(rhohard-rho0)*(1.-exp(-agesno(j)*86400.0/tau_dens))
+           ! blowing snow flux formula used in MAR
+           ws1(j)=(u1(j)**2+v1(j)**2)**0.5
+           ustar(j)=(cdragm(j)*(u1(j)**2+v1(j)**2))**0.5
+           ustart(j)=ustart0*exp(max(rhoice/rho0-rhoice/rhos(j),0.))*exp(max(0.,rhos(j)-rhomax)) 
+           ! we have multiplied by exp to prevent erosion when rhos>rhomax (usefull till
+           ! rhohard<450)
+       enddo
+       
+       ! computation of qbs at the top of the saltation layer
+       ! two formulations possible
+       ! pay attention that qbs is a mixing ratio and has to be converted
+       ! to specific content
+       
+       if (iflag_saltation_bs .eq. 1) then
+       ! expression from CRYOWRF (Sharma et al. 2022)
+          aa=2.6
+          bb=2.5
+          cc=2.0
+          lambdasalt=0.45
+          do j =1, knon
+               rhod=p1lay(j)/RD/temp_air(j)
+               nunu=max(ustar(j)/ustart(j),1.e-3)
+               fluxsalt=rhod/RG*(ustar(j)**3)*(1.-nunu**(-2)) * &
+                        (aa+bb*nunu**(-2)+cc*nunu**(-1))  
+               csalt=fluxsalt/(2.8*ustart(j))
+               hsalt(j)=0.08436*ustar(j)**1.27
+               qsalt(j)=1./rhod*csalt*lambdasalt*RG/(max(ustar(j)**2,1E-6)) &
+                       * exp(-lambdasalt*RG*hsalt(j)/max(ustar(j)**2,1E-6))
+               qsalt(j)=max(qsalt(j),0.)
+          enddo
+
+
+       else
+       ! default formulation from MAR model (Amory et al. 2021, Gallee et al. 2001)        
+          do j=1, knon
+              esalt=1./(3.25*max(ustar(j),0.001))
+              hsalt(j)=0.08436*ustar(j)**1.27
+              qsalt(j)=(max(ustar(j)**2-ustart(j)**2,0.))/(RG*hsalt(j))*esalt
+              !ep=qsalt*cdragm(j)*sqrt(u1(j)**2+v1(j)**2)
+          enddo
+       endif
+
+        ! calculation of erosion (flux positive towards the surface here) 
+        ! consistent with implicit resolution of turbulent mixing equation
+       do j=1, knon
+              i = knindex(j)
+              rhod=p1lay(j)/RD/temp_air(j)
+              ! Nemoto and Nishimura 2004 show that steady-state saltation is achieved within an interval of about 10s
+              ! we thus prevent snowerosion (snow particle transfer from the saltation layer to the first model level)
+              ! to exceed (in intensity) integrated over 10s to exceed the total mass of snow particle in the saltation layer
+              ! (rho*qsalt*hsalt)
+              maxerosion=hsalt(j)*qsalt(j)*rhod/10.
+              fluxbs(j)=rhod*ws1(j)*cdragm(j)*(AcoefQBS(j)-qsalt(j)) &
+                       / (1.-rhod*ws1(j)*cdragm(j)*BcoefQBS(j)*dtime)
+              !fluxbs(j)= rhod*ws1(j)*cdragm(j)*(qbs1(j)-qsalt(j))
+              fluxbs(j)=max(-maxerosion,fluxbs(j))
+
+              ! for outputs
+
+              zxustartlic(i) = ustart(j)
+              zxrhoslic(i) = rhos(j)
+       enddo
+
+  endif
+
+
+
+!****************************************************************************************
+! Calculate snow amount
+!    
+!****************************************************************************************
+    IF (ok_bs) THEN
+      precip_totsnow(:)=precip_snow(:)+precip_bs(:)
+      evap_totsnow(:)=evap(:)-fluxbs(:) ! flux bs is positive towards the surface (snow erosion)
+    ELSE
+      precip_totsnow(:)=precip_snow(:)
+      evap_totsnow(:)=evap(:)
+    ENDIF
+    
+ 
+    CALL fonte_neige(knon, is_lic, knindex, dtime, &
+         tsurf, precip_rain, precip_totsnow,  &
+         snow, qsol, tsurf_new, evap_totsnow)
+   
+    
+    WHERE (snow(1 : knon) .LT. 0.0001) agesno(1 : knon) = 0.                                         
+    zfra(1:knon) = MAX(0.0,MIN(1.0,snow(1:knon)/(snow(1:knon)+10.0)))  
 
 
@@ -378,6 +493,4 @@
     runoff(1:knon)=run_off_lic(1:knon)/dtime
 
-  
-!****************************************************************************************
        snow_o=0.
        zfra_o = 0.
@@ -420,6 +533,4 @@
 !albedo SB <<<
 
-  
-  
 
   END SUBROUTINE surf_landice
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_ocean_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_ocean_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_ocean_mod.F90	(revision 4727)
@@ -13,5 +13,5 @@
        windsp, rmu0, fder, tsurf_in, &
        itime, dtime, jour, knon, knindex, &
-       p1lay, z1lay, cdragh, cdragm, precip_rain, precip_snow, temp_air, spechum, &
+       p1lay, z1lay, cdragh, cdragm, precip_rain, precip_snow, precip_bs, temp_air, spechum, &
        AcoefH, AcoefQ, BcoefH, BcoefQ, &
        AcoefU, AcoefV, BcoefU, BcoefV, &
@@ -60,5 +60,5 @@
     REAL, DIMENSION(klon), INTENT(IN)        :: cdragh
     REAL, DIMENSION(klon), INTENT(IN)        :: cdragm
-    REAL, DIMENSION(klon), INTENT(IN)        :: precip_rain, precip_snow
+    REAL, DIMENSION(klon), INTENT(IN)        :: precip_rain, precip_snow, precip_bs
     REAL, DIMENSION(klon), INTENT(IN)        :: temp_air, spechum
     REAL, DIMENSION(klon), INTENT(IN)        :: AcoefH, AcoefQ, BcoefH, BcoefQ
@@ -144,4 +144,5 @@
     REAL, DIMENSION(klon) :: radsol
     REAL, DIMENSION(klon) :: cdragq ! Cdrag pour l'evaporation
+    REAL, DIMENSION(klon) :: precip_totsnow
     CHARACTER(len=20),PARAMETER :: modname="surf_ocean"
     real rhoa(knon) ! density of moist air  (kg / m3)
@@ -160,4 +161,15 @@
     radsol(1:klon) = 0.0 ! initialisation a priori inutile
     radsol(1:knon) = swnet(1:knon) + lwnet(1:knon)
+
+
+    !****************************************************************************************
+    !Total solid precip
+
+    IF (ok_bs) THEN
+       precip_totsnow(:)=precip_snow(:)+precip_bs(:)
+    ELSE
+       precip_totsnow(:)=precip_snow(:)
+    ENDIF
+
 
     !******************************************************************************
@@ -188,5 +200,5 @@
             windsp, fder, & 
             itime, dtime, knon, knindex, &
-            p1lay, cdragh, cdragq, cdragm, precip_rain, precip_snow,temp_air,spechum,& 
+            p1lay, cdragh, cdragq, cdragm, precip_rain, precip_totsnow,temp_air,spechum,& 
             AcoefH, AcoefQ, BcoefH, BcoefQ, &
             AcoefU, AcoefV, BcoefU, BcoefV, &
@@ -200,5 +212,5 @@
        CALL ocean_slab_noice( &
             itime, dtime, jour, knon, knindex, &
-            p1lay, cdragh, cdragq, cdragm, precip_rain, precip_snow, temp_air, spechum,&
+            p1lay, cdragh, cdragq, cdragm, precip_rain, precip_totsnow, temp_air, spechum,&
             AcoefH, AcoefQ, BcoefH, BcoefQ, &
             AcoefU, AcoefV, BcoefU, BcoefV, &
@@ -211,5 +223,5 @@
        CALL ocean_forced_noice( &
             itime, dtime, jour, knon, knindex, &
-            p1lay, cdragh, cdragq, cdragm, precip_rain, precip_snow, &
+            p1lay, cdragh, cdragq, cdragm, precip_rain, precip_totsnow, &
             temp_air, spechum, &
             AcoefH, AcoefQ, BcoefH, BcoefQ, &
@@ -326,5 +338,5 @@
        call bulk_flux(tkt, tks, taur, dter, dser, t_int, s_int, ds_ns, dt_ns, &
             u = windsp(:knon), t_ocean_1 = tsurf_new(:knon), s1 = sss(:knon), &
-            rain = precip_rain(:knon) + precip_snow(:knon), &
+            rain = precip_rain(:knon) + precip_totsnow(:knon), &
             hf = - fluxsens(:knon), hlb = - fluxlat(:knon), &
             rnl = - lwnet(:knon), &
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/sw_aeroAR4.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/sw_aeroAR4.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/sw_aeroAR4.F90	(revision 4727)
@@ -26,6 +26,6 @@
   IMPLICIT NONE
 
-#include "YOMCST.h"
-#include "clesphys.h"
+  INCLUDE "YOMCST.h"
+  INCLUDE "clesphys.h"
   !
   !     ------------------------------------------------------------------
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/tend_to_tke.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/tend_to_tke.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/tend_to_tke.F90	(revision 4727)
@@ -38,5 +38,5 @@
 
 IMPLICIT NONE
-#include "YOMCST.h"
+INCLUDE "YOMCST.h"
 
 ! Declarations
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/tracinca_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/tracinca_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/tracinca_mod.F90	(revision 4727)
@@ -30,9 +30,9 @@
 
     !--- COHERENCE TEST BETWEEN "type_trac" AND "config_inca"
-    IF(ANY(type_trac == ['inca','inco']) .AND. ALL(config_inca /= ['aero','aeNP','chem'])) CALL abort_gcm('tracinca_init', &
+    IF(ANY(type_trac == ['inca','inco']) .AND. ALL(config_inca /= ['aero','aeNP','chem'])) CALL abort_physic('tracinca_init', &
        'INCA enabled, but unknown config_inca = "'//TRIM(config_inca)//'". Please modify "run.def"', 1)
 
     !--- PROBLEM IF "config_inca" DIFFERS FROM "none" AND INCA HAS NOT BEEN ACTIVATED
-    IF(ALL(type_trac /= ['inca','inco'])  .AND.    config_inca /= 'none')                  CALL abort_gcm('tracinca_init', &
+    IF(ALL(type_trac /= ['inca','inco'])  .AND.    config_inca /= 'none')                  CALL abort_physic('tracinca_init', &
        'INCA disabled, but config_inca = "'//TRIM(config_inca)//'" should be "none". Please modify "run.def"', 1)
 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/tracreprobus_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/tracreprobus_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/tracreprobus_mod.F90	(revision 4727)
@@ -94,4 +94,5 @@
             t_seri,  & !argument phytrac (meme nom)
             pplay,   & !argument phytrac (meme nom)
+            paprs,   &
             pphi,    & !argument phytrac (meme nom)
             pphis,   & !argument phytrac (meme nom)
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/undefSTD.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/undefSTD.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/undefSTD.F90	(revision 4727)
@@ -8,13 +8,9 @@
   USE phys_state_var_mod
 #endif
-#ifdef CPP_XIOS
-  USE wxios, ONLY: missing_val
-#endif
+  USE wxios, ONLY: missing_val_xios => missing_val, using_xios
 
   IMPLICIT NONE
   include "clesphys.h"
-#ifndef CPP_XIOS 
   REAL :: missing_val
-#endif
 
   ! ====================================================================
@@ -37,5 +33,5 @@
   ! ====================================================================
 
-  ! ym#include "dimphy.h"
+  ! ymINCLUDE "dimphy.h"
   ! variables Input
 
@@ -59,7 +55,9 @@
 
 ! missing_val = nf90_fill_real
-#ifndef CPP_XIOS
+  IF (using_xios) THEN
+    missing_val=missing_val_xios
+  ELSE
       missing_val=missing_val_nf90
-#endif
+  ENDIF
 
   DO n = 1, nout
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/ustarhb.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/ustarhb.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/ustarhb.F90	(revision 4727)
@@ -2,6 +2,5 @@
 ! $Header$
 
-SUBROUTINE ustarhb(knon, u, v, cd_m, ustar)
-  USE dimphy
+SUBROUTINE ustarhb(klon, klev, knon, u, v, cd_m, ustar)
   IMPLICIT NONE
   ! ======================================================================
@@ -18,23 +17,16 @@
   ! model. J. of Climate, vol. 6, 1825-1842.
   ! ======================================================================
-  include "YOMCST.h"
 
   ! Arguments:
 
-  INTEGER knon ! nombre de points a calculer
-  REAL u(klon, klev) ! vitesse U (m/s)
-  REAL v(klon, klev) ! vitesse V (m/s)
-  REAL cd_m(klon) ! coefficient de friction au sol pour vitesse
-  REAL ustar(klon)
+  INTEGER, INTENT(IN) :: klon, klev, knon ! nombre de points a calculer
+  REAL, DIMENSION(klon, klev), INTENT(IN) :: u,v ! vent horizontal (m/s)
+  REAL, DIMENSION(klon), INTENT(IN) :: cd_m ! coefficient de friction au sol pour vitesse
+  REAL, DIMENSION(klon), INTENT(OUT) :: ustar
 
-  INTEGER i, k
-  REAL zxt, zxq, zxu, zxv, zxmod, taux, tauy
-  REAL zx_alf1, zx_alf2 ! parametres pour extrapolation
-  LOGICAL unssrf(klon) ! unstb pbl w/lvls within srf pbl lyr
-  LOGICAL unsout(klon) ! unstb pbl w/lvls in outer pbl lyr
-  LOGICAL check(klon) ! True=>chk if Richardson no.>critcal
+  INTEGER :: i, k
+  REAL :: zxt, zxq, zxu, zxv, zxmod, taux, tauy
+  REAL :: zx_alf1, zx_alf2 ! parametres pour extrapolation
 
-  include "YOETHF.h"
-  include "FCTTRE.h"
   DO i = 1, knon
     zx_alf1 = 1.0
@@ -46,5 +38,4 @@
     tauy = zxv*zxmod*cd_m(i)
     ustar(i) = sqrt(taux**2+tauy**2)
-    ! print*,'Ust ',zxu,zxmod,taux,ustar(i)
   END DO
 
